﻿package com
{

	import com.greensock.TweenLite;
	import com.greensock.easing.*;

	import flash.display.*;
	import flash.events.*;
	import flash.net.*;

	public class Main extends MovieClip
	{

		private var showingInstructions:Boolean = false;
		private var game:Game;

		public function Main()
		{
			this.addEventListener(Event.ADDED, init);
		}

		private function init(e:Event):void
		{
			this.removeEventListener(Event.ADDED, init);

			// set up listeners, positions, visibility, etc
			newGame_btn.buttonMode = true;
			instructions_btn.buttonMode = true;
			followMe_btn.buttonMode = true;
			instructions_content.close_btn.buttonMode = true;

			newGame_btn.addEventListener(MouseEvent.CLICK, startGame);
			instructions_btn.addEventListener(MouseEvent.CLICK, instructionsHandler);
			instructions_content.close_btn.addEventListener(MouseEvent.CLICK, instructionsHandler);
			followMe_btn.addEventListener(MouseEvent.CLICK, followMeHandler);
		}

		private function startGame(e:MouseEvent):void
		{
			loadingTweets.x = 130;
			loadingTweets.y = 230;
			loadingTweets.alpha = 0;

			TweenLite.to(newGame_btn, .3, {x:-200, ease:Quad.easeIn});
			TweenLite.to(instructions_btn, .3, {x:500, ease:Quad.easeIn});
			TweenLite.to(followMe_btn, .3, {y:650, ease:Quad.easeIn});
			TweenLite.to(loadingTweets, .3, {alpha:1, delay: .2});

			menu_btn.buttonMode = true;
			menu_btn.addEventListener(MouseEvent.CLICK, goToMenu);
			TweenLite.to(menu_btn, .3,{y:0, delay:.2, ease:Quad.easeOut});
			TweenLite.to(score_text, .3,{y:10, delay:.2, ease:Quad.easeOut});

			if (showingInstructions)
			{
				TweenLite.to(instructions_content, .3,{y:600, ease:Quad.easeIn});
				showingInstructions = false;
			}

			game = new Game();
			game.addEventListener(GameEvent.GAME_ENDED, endGame);
			game.addEventListener(GameEvent.SCORE_CHANGE, changeScore);
			game.addEventListener(GameEvent.TWEETS_READY, addGame);
			game.addEventListener(GameEvent.TWEETS_ERROR, errorHandler);
		}

		private function errorHandler(e:GameEvent):void
		{
			loadingTweets.gotoAndStop(2);
		}

		private function addGame(e:Event):void
		{
			addChild(game);

			TweenLite.to(title, .3, {y:-200, ease:Quad.easeIn});
			loadingTweets.alpha = 0;
			loadingTweets.x = 800;
			loadingTweets.y = 2300;
		}

		private function instructionsHandler(e:MouseEvent):void
		{
			if (showingInstructions)
			{
				TweenLite.to(instructions_content, .4,{y:600, ease:Quad.easeIn});
				showingInstructions = false;
			}
			else
			{
				TweenLite.to(instructions_content, .4,{y:364, ease:Quad.easeOut});
				showingInstructions = true;
			}
		}

		private function endGame(e:GameEvent = null):void
		{
			score_text.text = "Score: 0";
			game.killGame();

			game.removeEventListener(GameEvent.GAME_ENDED, endGame);
			game.removeEventListener(GameEvent.SCORE_CHANGE, changeScore);
			game.removeEventListener(GameEvent.TWEETS_READY, addGame);
			game.removeEventListener(GameEvent.TWEETS_ERROR, errorHandler);

			if (game.addedToStage)
			{
				TweenLite.to(game, .4, {alpha:0, onComplete:(function (){game.parent.removeChild(game); game = null})});
			}
			else
			{
				game = null;

				loadingTweets.alpha = 0;
				loadingTweets.x = 800;
				loadingTweets.y = 2300;
			}
		}

		private function changeScore(e:GameEvent):void
		{
			var s:String = e.parameters;
			score_text.text = "Score: " + s;
		}

		private function goToMenu(e:MouseEvent):void
		{
			menu_btn.removeEventListener(MouseEvent.CLICK, goToMenu);

			TweenLite.to(title, .3, {y:91, delay:.2, ease:Quad.easeOut});
			TweenLite.to(newGame_btn, .3, {x:162, delay:.2, ease:Quad.easeOut});
			TweenLite.to(instructions_btn, .3, {x:162, delay:.2, ease:Quad.easeOut});
			TweenLite.to(followMe_btn, .3, {y:500, delay:.2, ease:Quad.easeOut});
			TweenLite.to(menu_btn, .3,{y:-35, ease:Quad.easeIn});
			TweenLite.to(score_text, .3,{y:-30, ease:Quad.easeIn});

			endGame();
		}

		private function followMeHandler(e:MouseEvent):void
		{
			navigateToURL(new URLRequest("http://www.twitter.com/jscamposcr"), "_blank");
		}
	}
}